;------------------------------------------------------------------------------------------------------------
;  Herisson v.1.0     -     Decryptor for Escargot
;     By elooo        -     http://elooo.c.la
;------------------------------------------------------------------------------------------------------------
;  A few notes before beginning :
;  There is no need :
;    - to write a small debugger to decrypt the code because the encryption key is always 0x40
;    - to rebuild the IAT or the Import Table because they are not destroyed (encrypted only)
;    - to "guess" the address of the Import table because it is always present at (the address of the
;   last section (created by Escargot) + 0x81) 
;    - to look for the exact place of the Original EntryPoint as it is always stored at (the address of the
;   last section + 0x15C)
;
;  So, it will be a very lame decryptor but why would I make the simple complicated ? :) 
;  Let me know if a debugger is needed. If so, I will write it and I will provide my source code too.
;------------------------------------------------------------------------------------------------------------

;------------------------------------------------------------------------------------------------------------
.486p
.model flat, stdcall
option casemap :none

;--------------------------------------------------------------------------------
;  Includes
;--------------------------------------------------------------------------------
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\kernel32.lib

;--------------------------------------------------------------------------------
;  Macros
;--------------------------------------------------------------------------------
	CreateData MACRO quoted_text:VARARG
	LOCAL Local_Etiquette
	.data
	Local_Etiquette db quoted_text,0
	.code
	EXITM <Local_Etiquette>
	ENDM
	
	SADD MACRO quoted_text:VARARG
	EXITM <ADDR CreateData(quoted_text)>
	ENDM
	
;--------------------------------------------------------------------------------
;  Defined data
;--------------------------------------------------------------------------------	
.data
ofn		   				OPENFILENAME <>

AppNameOpen				db "Herisson : Elooo's Decryptor for Escargot - Open a file",0
AppNameSave				db "Herisson : Elooo's Decryptor for Escargot - Save the file",0
Filter 					db "Encrypted files",0,0,0
Filter2 				db "Decrypted Files",0,0,0
	
;--------------------------------------------------------------------------------
;  Undefined data
;--------------------------------------------------------------------------------	
.data?
bufferName 				db 512 dup(?)			; name of the file
hFile					dd ?					; file handle
FileSize				dd ?					; Size of the file
NewFileSize				dd ?					; new size of the file
ptrMap					dd ?					; pointer to the mapped file
NbSections				dd ?					; number of sections
OffSect1				dd ?					; offset of the first section
OffSect2				dd ?					; offset of the second section
OffLastSect	 			dd ?					; offset of the last section
OEP						dd ?					; VA of the OEP
addrIT					dd ?					; VA of the Import Table
Bytes					dd ?					; number of read/written bytes

;--------------------------------------------------------------------------------
;  Code
;--------------------------------------------------------------------------------	
.code
start:
;--------------------------------------------------
;   Open file dialog
;--------------------------------------------------
	mov ofn.lStructSize,SIZEOF ofn
	mov  ofn.lpstrFilter, OFFSET Filter
	mov  ofn.lpstrFile, OFFSET bufferName
	mov ofn.lpstrTitle,offset AppNameOpen
	mov  ofn.nMaxFile,512
	mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
	invoke GetOpenFileName, ADDR ofn
	
	.if eax!=NULL
		invoke CreateFile,addr bufferName, GENERIC_READ, FILE_SHARE_READ,NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,NULL
		.if eax!=INVALID_HANDLE_VALUE
			mov hFile,eax
			;--------------------------------------------------
			;   Map the file into memory
			;--------------------------------------------------
			invoke GetFileSize, hFile, NULL
			.if eax!=NULL
				mov FileSize, eax
				invoke VirtualAlloc, 0, FileSize, MEM_COMMIT, PAGE_READWRITE
				.if eax!=NULL
					mov ptrMap,eax
					invoke ReadFile, hFile,	ptrMap, FileSize, offset Bytes, NULL
					.if eax!=NULL						
						invoke	CloseHandle, hFile
						;--------------------------------------------------
						;   Get info about the encrypted file
						;--------------------------------------------------
						call GetInfo 
						test eax, eax
						jz Bad
						;--------------------------------------------------
						;   Decrypt the first section (the only one encrypted)
						;--------------------------------------------------	
						mov ecx, OffSect1	
						mov edx, OffSect2
						add ecx, ptrMap	
						add edx, ptrMap			
						.while (ecx < edx)
							xor byte ptr [ecx], 40h
							inc ecx
						.endw
						;--------------------------------------------------
						;   Remove the last section and rebuild the file
						;--------------------------------------------------	
						call Rebuild
						test eax, eax
						jz Bad
						;--------------------------------------------------
						;   Save the decrypted file
						;--------------------------------------------------						
						call SaveFile
						test eax, eax
						jz Bad						
						invoke	VirtualFree, ptrMap, FileSize, MEM_DECOMMIT
						invoke	CloseHandle, hFile
						invoke MessageBox,NULL, SADD("File decrypted"),SADD("Finish !"), MB_OK+MB_ICONINFORMATION
						jmp finish
												
Bad:
						invoke	VirtualFree, ptrMap, FileSize, MEM_DECOMMIT
						invoke	CloseHandle, hFile
						jmp finish		
	       			;--------------------------------------------------
					;   Error ReadFile
					;--------------------------------------------------
					.else
						invoke	VirtualFree, ptrMap, FileSize, MEM_DECOMMIT
						invoke	CloseHandle, hFile
						invoke MessageBox,NULL, SADD("ReadFile"),SADD("Error"), MB_OK+MB_ICONERROR	
						jmp finish									
					.endif											
       			;--------------------------------------------------
				;   Error VirtualAlloc
				;--------------------------------------------------
				.else
					invoke	CloseHandle, hFile
					invoke MessageBox,NULL, SADD("VirtualAlloc"),SADD("Error"), MB_OK+MB_ICONERROR	
					jmp finish									
				.endif
       		;--------------------------------------------------
			;   Error GetFileSize
			;--------------------------------------------------				
			.else
				invoke	CloseHandle, hFile
				invoke MessageBox,NULL, SADD("GetFileSize"),SADD("Error"), MB_OK+MB_ICONERROR	
				jmp finish	 
			.endif
		;--------------------------------------------------
		;   Error CreateFile
		;--------------------------------------------------
		.else
			invoke MessageBox,NULL, SADD("CreateFile"),SADD("Error"), MB_OK+MB_ICONERROR	
			jmp finish
		.endif
	;--------------------------------------------------
	;   Error GetOpenFileName
	;--------------------------------------------------	
	.else
		invoke MessageBox,NULL, SADD("GetOpenFileName"),SADD("Error"), MB_OK+MB_ICONERROR				
	.endif	

;--------------------------------------------------
;   Aborted / Finished  
;--------------------------------------------------
finish:	
	invoke ExitProcess, 0	

GetInfo proc
;--------------------------------------------------------------------------------
;  - Get the beginning of the first / second section
;  - Get the offset of the last section 
;  - Check if the file is encrypted with Escargot
;  - If so, get the OEP and the address of the Import Table
;--------------------------------------------------------------------------------	

	mov edi, ptrMap
	assume edi:ptr IMAGE_DOS_HEADER  
	.if [edi].e_magic==IMAGE_DOS_SIGNATURE
		add edi, [edi].e_lfanew						
		assume edi:ptr IMAGE_NT_HEADERS
		.if [edi].Signature==IMAGE_NT_SIGNATURE
			;--------------------------------------------------
			;   Get the number of sections
			;--------------------------------------------------		
			movzx eax, [edi].FileHeader.NumberOfSections
			mov NbSections, eax			
			;--------------------------------------------------
			;   Get the beginning of the first section
			;--------------------------------------------------			
			add edi, sizeof IMAGE_NT_HEADERS
			assume edi:ptr IMAGE_SECTION_HEADER
			push [edi].PointerToRawData
			pop OffSect1
			;--------------------------------------------------
			;   Get the beginning of the second section
			;--------------------------------------------------			
			add edi, sizeof IMAGE_SECTION_HEADER
			push [edi].PointerToRawData			
			pop OffSect2
			;--------------------------------------------------
			;   Get the beginning of the last section
			;--------------------------------------------------	
			mov ecx, NbSections
			dec ecx							
			.while (ecx != 1)
				dec ecx
				add edi, sizeof IMAGE_SECTION_HEADER
			.endw
			push [edi].PointerToRawData
			pop OffLastSect 	
			;--------------------------------------------------
			;   Check if the file is encrypted with Escargot
			;--------------------------------------------------	
			mov edx, OffLastSect
			add edx, ptrMap		
			mov eax, dword ptr [edx+2]
			cmp eax, 312E3040h
			jz OKEscargot
			;--------------------------------------------------
			;   Signature not recognized
			;--------------------------------------------------					
			invoke MessageBox,NULL, SADD("This file is not encrypted with Escargot"),SADD("Error"), MB_OK+MB_ICONERROR	
			xor eax, eax
			ret	
			
OKEscargot:								  						
			;--------------------------------------------------
			;   Get the OEP  and the address of the Import Table
			;--------------------------------------------------			
			mov eax, dword ptr [edx+15Ch]
			mov OEP, eax
			mov eax, dword ptr [edx+81h]
			mov addrIT, eax					
		;--------------------------------------------------
		;   It is not a valid PE file
		;--------------------------------------------------	
		.else
			invoke MessageBox,NULL, SADD("It is not a valid PE file"),SADD("Error"), MB_OK+MB_ICONERROR	
			xor eax, eax
			ret
		.endif
	;--------------------------------------------------
	;   It is not a DOS/Windows executable file
	;--------------------------------------------------		
	.else
		invoke MessageBox,NULL, SADD("It is not a DOS/Windows executable file"),SADD("Error"), MB_OK+MB_ICONERROR	
		xor eax, eax
	.endif


	RET
GetInfo EndP	

Rebuild proc
;--------------------------------------------------------------------------------
;  - Remove the last section
;  - Store the RVA of the OEP in the PE header
;  - Fix the address of the Import Table
;  - Fix the SizeOfImage
;  - Get the size of the new file
;--------------------------------------------------------------------------------	

	mov edi, ptrMap
	assume edi:ptr IMAGE_DOS_HEADER  
	add edi, [edi].e_lfanew						
	assume edi:ptr IMAGE_NT_HEADERS
	;--------------------------------------------------
	;   Remove the last section
	;--------------------------------------------------	
	mov ax, [edi].FileHeader.NumberOfSections
	dec ax
	mov [edi].FileHeader.NumberOfSections, ax
	;--------------------------------------------------
	;   Store the RVA of the OEP in the PE header
	;--------------------------------------------------
	mov esi, edi
	assume esi:ptr IMAGE_NT_HEADERS
	mov eax, [esi].OptionalHeader.ImageBase
	sub OEP, eax
	push OEP
	pop [esi].OptionalHeader.AddressOfEntryPoint
	;--------------------------------------------------
	;   Fix the address of the Import Table
	;--------------------------------------------------
	mov eax, [esi].OptionalHeader.ImageBase
	sub addrIT, eax
	push addrIT
	pop [esi].OptionalHeader.DataDirectory[8].VirtualAddress		;IMAGE_DIRECTORY_ENTRY_IMPORT.VirtualAddress
	mov [esi].OptionalHeader.DataDirectory[96].VirtualAddress, 0 	;IMAGE_DIRECTORY_ENTRY_IAT.VirtualAddress
	mov [esi].OptionalHeader.DataDirectory[100].VirtualAddress, 0 	;IMAGE_DIRECTORY_ENTRY_IAT.Size
	;--------------------------------------------------
	;   Fix the BaseOfCode
	;--------------------------------------------------	
	add edi, sizeof IMAGE_NT_HEADERS
	assume edi:ptr IMAGE_SECTION_HEADER
	push [edi].VirtualAddress										
	pop [esi].OptionalHeader.BaseOfCode	
	;--------------------------------------------------
	;   Fix the SizeOfImage
	;--------------------------------------------------	
	mov eax, NbSections
	dec eax
	dec eax
	mov ecx, sizeof IMAGE_SECTION_HEADER
	mul ecx
	add edi, eax
	mov eax, [edi].VirtualAddress	
	add eax, [edi].Misc.VirtualSize 
	push eax
	pop [esi].OptionalHeader.SizeOfImage	
	;--------------------------------------------------
	;   Get the size of the new file
	;--------------------------------------------------	
	mov eax, [edi].PointerToRawData
	add eax, [edi].SizeOfRawData
	push eax
	pop NewFileSize	
	RET
Rebuild EndP

SaveFile proc
;--------------------------------------------------
;   Save file dialog
;--------------------------------------------------
	mov ofn.lStructSize,SIZEOF ofn
	mov  ofn.lpstrFilter, OFFSET Filter2
	mov  ofn.lpstrFile, OFFSET bufferName
	mov dword ptr ds:bufferName,0
	mov ofn.lpstrTitle,offset AppNameSave
	mov  ofn.nMaxFile,512
	mov  ofn.Flags, OFN_PATHMUSTEXIST or OFN_LONGNAMES or  OFN_EXPLORER
	invoke GetSaveFileName, ADDR ofn
	
	.if eax!=NULL	
		;--------------------------------------------------		
		; Create the decrypted file
		;--------------------------------------------------		
		invoke CreateFile, addr bufferName, GENERIC_READ+GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
		.if eax!=INVALID_HANDLE_VALUE
			mov hFile, eax
			invoke WriteFile, hFile, ptrMap, NewFileSize, offset Bytes, NULL
			test eax, eax
			jz BadWrite
			ret
BadWrite:
		;--------------------------------------------------	
		; Error WriteFile
		;--------------------------------------------------						
			invoke MessageBox,NULL, SADD("WriteFile"),SADD("Error"), MB_OK+MB_ICONERROR	
			xor eax, eax
			ret				
		;--------------------------------------------------	
		; Error CreateFile
		;--------------------------------------------------				
		.else
			invoke MessageBox,NULL, SADD("CreateFile"),SADD("Error"), MB_OK+MB_ICONERROR	
			xor eax, eax
			ret
		.endif			
	;--------------------------------------------------
	; Error GetSaveFileName
	;--------------------------------------------------			
	.else
		invoke MessageBox,NULL, SADD("GetSaveFileName"),SADD("Error"), MB_OK+MB_ICONERROR
		xor eax, eax			
	.endif
	
	Ret
SaveFile EndP

END start	